---
- name: Set Automation Controller job template variables
  ansible.builtin.set_fact:
    aapctl_job_template_name: "{{ aap_controller_job_template_name }}"
    aapctl_job_template_inventory: "{{ aap_controller_job_template_inventory }}"
    aapctl_job_template_project: "{{ aap_controller_job_template_project }}"
    aapctl_job_template_playbook: "{{ aap_controller_job_template_playbook }}"

- name: Create Ansible Automation Controller job template
  kubernetes.core.k8s:
    definition:
      apiVersion: tower.ansible.com/v1alpha1
      metadata:
        name: "{{ aapctl_instance_name }}-job-template"
        namespace: "{{ aap_operator_namespace }}"
      kind: JobTemplate
      spec:
        job_template_name: "{{ aapctl_job_template_name }}"
        job_template_inventory: "{{ aapctl_job_template_inventory }}"
        job_template_project: "{{ aapctl_job_template_project }}"
        job_template_playbook: "{{ aapctl_job_template_playbook }}"
        tower_auth_secret: "{{ aapctl_instance_name }}-auth-secret"
    state: present

- name: Wait till Automation Controller job template finishes 
  kubernetes.core.k8s_info:
    api_version: tower.ansible.com/v1alpha1
    kind: JobTemplate
    name: "{{ aapctl_instance_name }}-job-template"
    namespace: "{{ aap_operator_namespace }}"
  register: aapctl_job_template_obj
  until:
    - aapctl_job_template_obj.resources[0].status.conditions[0].ansibleResult is defined
    - aapctl_job_template_obj.resources[0].status |
       json_query('conditions[?reason==`Successful`].type') == ["Running"]
  retries: 20
  delay: 10
